import React, { PureComponent } from 'react'
require('./index.scss')

export default class ConcatsCard extends PureComponent {
  showMorePerson (e) {
    $(e.currentTarget).find('.more-person-area').removeClass('hide')
  }
  hideMorePerson (e) {
    $(e.currentTarget).find('.more-person-area').addClass('hide')
  }
  render () {
    return (
      <div className="concats_card_wrap">
        <ul className='concats-card__list'>
          {this.props.dataSource.sameCompanyDataSource.map((item, index) => {
            return <li className='concats-card__container' key={index}>
                      <div className='concats-card__title'>
                        同在<span className='concats-card__company_quotes'>「</span><span className='concats-card__company'>{item.Name}</span><span className='concats-card__company_quotes'>」</span>工作过
                      </div>
                      <div className='concats-card__content'>
                        <div className='concats-card__info'>
                          <div className='concats-card__number-info'>
                            <span className='concats-card__number'>{item.Persons.length}</span>
                            <span className='concats-card__text'>人</span>
                          </div>
                          <div className='concats-card__name-info' ref='concats-card__name-info'>
                            <div className='concats-card__name-info_wrapper' ref='concats-card__name-info_wrapper'>
                              {item.Persons.map(onePerson => {
                                return <a className={`concats-card__name ${this.props.isElink ? '' : 'enable-click-name'}`} target={this.props.isElink ? '' : '_blank'} href={this.props.isElink ? 'javascript:void(0);' : '/Recruiting/ApplicantOverview/ApplicantDetailInfo?personId=' + onePerson.PersonId + '&' + 'jobId='}>
                                          {onePerson.Name}
                                        </a>
                              })}
                            </div>
                          </div>
                        </div>
                      </div>
                      <div className={`concats-card__more ${item.Persons.length > 5 ? '' : 'hide'} `} onMouseOver={this.showMorePerson.bind(this)} onMouseOut={this.hideMorePerson.bind(this)}>
                        <span>更多>></span>
                        <div className="more-person-area hide">
                          <div className="content">
                          {item.Persons.map(onePerson => {
                              return <a className={`concats-card__name ${this.props.isElink ? '' : 'enable-click-name'}`} target={this.props.isElink ? '' : '_blank'} href={this.props.isElink ? 'javascript:void(0);' : '/Recruiting/ApplicantOverview/ApplicantDetailInfo?personId=' + onePerson.PersonId + '&' + 'jobId='}>
                                      {onePerson.Name}
                                    </a>
                            })}
                          </div>
                        </div>
                      </div>
                    </li>
          })}
          {this.props.dataSource.sameSchoolDataSource.map((item, index) => {
            return <li className='concats-card__container' key={index}>
                      <div className='concats-card__title'>
                        同在<span className='concats-card__company_quotes'>「</span><span className='concats-card__company'>{item.Name}</span><span className='concats-card__company_quotes'>」</span>学习过
                      </div>
                      <div className='concats-card__content'>
                        <div className='concats-card__info'>
                          <div className='concats-card__number-info'>
                            <span className='concats-card__number'>{item.Persons.length}</span>
                            <span className='concats-card__text'>人</span>
                          </div>
                          <div className='concats-card__name-info' ref='concats-card__name-info'>
                            <div className='concats-card__name-info_wrapper' ref='concats-card__name-info_wrapper'>
                              {item.Persons.map(onePerson => {
                                return <a className={`concats-card__name ${this.props.isElink ? '' : 'enable-click-name'}`} target={this.props.isElink ? '' : '_blank'} href={this.props.isElink ? 'javascript:void(0);' : '/Recruiting/ApplicantOverview/ApplicantDetailInfo?personId=' + onePerson.PersonId + '&' + 'jobId='}>
                                          {onePerson.Name}
                                        </a>
                              })}
                            </div>
                          </div>
                        </div>
                      </div>
                      <div className={`concats-card__more ${item.Persons.length > 5 ? '' : 'hide'} `} onMouseOver={this.showMorePerson.bind(this)} onMouseOut={this.hideMorePerson.bind(this)}>
                        <span>更多>></span>
                        <div className="more-person-area hide">
                          <div className="content">
                            {item.Persons.map(onePerson => {
                              return <a className={`concats-card__name ${this.props.isElink ? '' : 'enable-click-name'}`} target={this.props.isElink ? '' : '_blank'} href={this.props.isElink ? 'javascript:void(0);' : '/Recruiting/ApplicantOverview/ApplicantDetailInfo?personId=' + onePerson.PersonId + '&' + 'jobId='}>
                                      {onePerson.Name}
                                    </a>
                            })}
                          </div>
                        </div>
                      </div>
                    </li>
          })}
        </ul>
        <div className={`no-data ${(this.props.dataSource.sameCompanyDataSource.length !== 0 || this.props.dataSource.sameSchoolDataSource.length !== 0) ? 'hide' : ''} `} >
          暂无数据
        </div>
      </div>
    )
  }
}
