import React,{ PureComponent} from 'react';
import BaseComponent from '../BaseComponent';
import Popup from '../popup'
import ResumeCard from './resumeCard'
import ConcatsCard from './concatsCard'
import SimilarTalentCard from './similarTalentCard'
import IntellRecommendCard from './intellRecommendCard'
require('./index.scss');

export default class AiCard extends BaseComponent{
    constructor(props){
        super(props);

        this.state = {
          isShowPop: false,
          currentItem: null,
          list: [
            {id: 1, value: '基本条件不符合', isChecked: false},
            {id: 2, value: '学历不符合', isChecked: false},
            {id: 3, value: '工作经历不符合', isChecked: false},
            {id: 4, value: '技能要求不符合', isChecked: false},
            {id: 5, value: '不合眼缘', isChecked: false}
          ],
        }
        this.handleChange = this.handleChange.bind(this)
        this.handleTextChange = this.handleTextChange.bind(this)
        this.selectedData = []
        this.textVal = ''
    }

    // 弹窗配置
    popupConfig = () => {
      let config = {
        title: '选择不合适理由',
        list: this.state.list,
        placeholder: '我要吐槽其他理由',
        onCancel: this.handleCancel,
        onSubmit: this.handleSubmit,
        onChange: this.handleChange,
        onTextChange: this.handleTextChange,
        width: '372px',
        height: '319px'
      }

      return config
    }

    // 根据不同的参数render不同的card
    renderCardContent = (data) => {
      let SOURCE_TYPE = {
        ResumeCard: '1',  // 简历可信度
        ConcatsCard: '2',  // 人脉
        SimilarTalentCard: '3',  // 相似人才
        IntellRecommendCard: '4'  // 智能推荐
      }

      switch(data.cardType) {
        case SOURCE_TYPE.ResumeCard:
          return (<ResumeCard {...data}/>)
        case SOURCE_TYPE.ConcatsCard:
          return (<ConcatsCard {...data}/>)
        case SOURCE_TYPE.SimilarTalentCard:
          return (<SimilarTalentCard {...data}/>)
        case SOURCE_TYPE.IntellRecommendCard:
          return (<IntellRecommendCard showRefuseDialog={this.showRefuseDialog.bind(this)} {...data}/>)
        default:
          return
      }
    }
    // 不合适
    showRefuseDialog = (type, data) => {
      this.setState({
        isShowPop: true,
        currentItem: data,
        list: this.state.list.map((item) => {
          item.isChecked = false
          return item
        })
      })
    }

    // textarea change
    handleTextChange (event) {
      this.textVal = event.target.value
    }

    // input change
    handleChange (data){
      let list = this.state.list, selectedItems = []
      this.setState({
        list: list.map((item) => {
          if(item.id === data.id) item.isChecked = !item.isChecked
          return item
        })
      })

      list.filter((item) => {
        return item.isChecked
      }).map((item) => {
        selectedItems.push(item.value)
      })
      this.selectedData = selectedItems
    }

    // 取消／关闭弹窗
    handleCancel = () => {
      this.setState({
        isShowPop: false
      })
    }

    // 确定／提交
    handleSubmit = (type, data) => {
      this.selectedData.push(this.textVal)
      let submitData = this.state.currentItem
      submitData.Reason = this.selectedData
      this.props.handleSubmit(0, submitData)
      this.setState({
        isShowPop: false
      })
    }
    handleRefuse = (data) => {
      this.props.handleSubmit(data)
    }

    render(){
      const {isShowPop} = this.state
      const popupConfig = this.popupConfig()
      return (
          <div className="card_wrap">
              {this.renderCardContent({...this.props})}
              {
                isShowPop && <Popup {...popupConfig}/>
              }
          </div>
      );
    }
}
