import React,{ Component} from 'react';
require('./index.scss');
export default class IntellRecommendCard extends Component {
  constructor(props){
    super(props)
  }
  handleClick(type, data){
    if(type) {
      this.props.handleSubmit(type, data)
    }else{
      this.props.showRefuseDialog(type, data)
    }
  }
  cardClick(data) {
    if (data.Accept !== false ) {
      window.open(data.detailUrl)
    }
  }
  render() {
    return (
      <div className="intelligent_recommend_wrap">
        <ul>
          {this.props.dataSource.map((item, index) => {
            return (
              <li className={`card_item ${item.IsSuccess ? 'card_item_disabled' : ''}`} key={index}>
                <div className="basic_info" onClick={this.cardClick.bind(this, item)}>
                    <div className="basic_header">
                        <div className="avatar">
                           <img src={item.IDPhoto}/>
                        </div>
                        <div className="name_work">
                          <span className="name" title={item.Name}>{item.Name}</span>
                          <span>工作经验 {item.YearsOf || '无'}</span>
                        </div>
                        <div className="match">
                          <label>匹配度</label>
                          <span>{Math.round(item.JobScore * 100)}<i class="symbol">%</i></span>
                        </div>
                    </div>
                    <ul className="info_list">
                      <li>
                        <label>毕业学校</label>
                        <div>
                          <span title={item.R_LastSchool}>{item.R_LastSchool}{item.R_lastEducationLevel}</span>
                          <span className="edu_time">{item.R_LastEduStartDate}-{item.R_LastEduEndDate}</span>
                        </div>
                      </li>
                      <li>
                        <label>最近工作单位</label>
                        <span title={item.R_LastCompany}>{item.R_LastCompany || '无'}</span>
                      </li>
                      <li>
                        <label>最近工作职位</label>
                        <span>{item.R_LastJobTitle || '无'}</span>
                      </li>
                    </ul>
                </div>
                <div className="operate_btns">
                    {
                      item.IsSuccess ?
                      (item.Accept ?
                      <a href="javascript:void(0);" className="submitted">已接受</a>
                      :
                      <a href="javascript:void(0);" className="submitted">已拒绝</a>)
                      :
                      <div>
                        <a href="javascript:void(0);" onClick={this.handleClick.bind(this, 0, item)} ref="notPass">不合适</a>
                        <a href="javascript:void(0);" onClick={this.handleClick.bind(this, 1, item)} className="btn_save">接受</a>
                      </div>
                    }
                </div>
              </li>
            )
          })}
        </ul>
        <div className={`no-data ${this.props.dataSource.length === 0 ? '' : 'hide'} `} >
          暂无数据
        </div>
      </div>
    )
  }
}
