import React,{ PureComponent} from 'react';
require('./index.scss');

export default class ResumeCard extends PureComponent {
  constructor(props){
    super(props)
  }
  render() {
    const keys = Object.keys(this.props.dataSource)
    return (
      <div className="resume_wrap">
        {
          keys.map((keyy, index) => {
            return (<div key={index} className={`resume_item ${(this.props.dataSource[keyy] && this.props.dataSource[keyy].length > 0) ? '' : 'hide'}`}>
              <h3>{keyy === 'Education' ? '教育背景' : '工作经验'}</h3>
              <ul>
                {
                  this.props.dataSource[keyy] && this.props.dataSource[keyy].map((item, index) => {
                    return (
                      <li key={index}>
                        <span>{ item.Date }{ item.SubDim }</span>
                      </li>
                    )
                  })
                }
              </ul>
            </div>)
          })
        }
        {
          keys.length === 1 && <div className={'resume_item hidden'}>
          <h3>工作经验</h3>
          <ul>
            <li>
              <span>2008年03月~2009年08月的工作时长不同</span>
            </li>
          </ul>
        </div>
        }
        <div className={`no-data ${JSON.stringify(this.props.dataSource) === '{}' ? '' : 'hide'}`} >
          暂无数据
        </div>
      </div>
    )
  }
}

