import React,{ PureComponent} from 'react';
require('./index.scss');

export default class SimilarTalentCard extends PureComponent {
  constructor(props){
    super(props)
  }
  showMoreKills (e) {
    $(e.currentTarget).find('.more-kill-area').removeClass('hide')
  }
  hideMoreKills (e) {
    $(e.currentTarget).find('.more-kill-area').addClass('hide')
  }
  render() {
    return (
      <div className="similar_talent_wrap">
        <ul>
          {this.props.dataSource.map((item, index) => {
            return (
              <li className="card_item" key={index} >
                <div className="basic_info">
                    <div className="basic_header">
                        <span className="name_photo">
                          <img src={item.photo}/>
                          <span title={item.name} className="name">{item.name}</span>
                          <span title={item.school + item.degree} className={`school ${item.school ? '' : 'hide'} `}>{item.school}{item.degree ? '(' + item.degree + ')' : ''}</span>
                        </span>
                    </div>
                </div>
                <ul className="assessments_list">
                  <li className={`assessment_item assesement_wrap ${(item.assessments.IBA && item.assessments.IBA.title) ? '' : 'hide'}`}>
                    <div className="similarity">
                      <span>{Math.round(item.assessments.IBA.similarity * 100)}</span>
                      <span class="symbol">%</span>
                    </div>
                    <div className="info">
                      <label title={item.assessments.IBA.title}>{item.assessments.IBA.title}</label>
                      <div className="assessment_label">
                        {item.assessments.IBA.match && item.assessments.IBA.match.map((subItem, index) => {
                          return (
                            <span title={subItem} key={index}>#{subItem}</span>
                          )
                        })}
                      </div>
                    </div>
                  </li>
                  <li className={`assessment_item assesement_wrap ${(item.assessments.Competency && item.assessments.Competency.title) ? '' : 'hide'}`}>
                    <div className="similarity">
                      <span>{Math.round(item.assessments.Competency.similarity * 100)}</span>
                      <span class="symbol">%</span>
                    </div>
                    <div className="info">
                      <label title={item.assessments.Competency.title}>{item.assessments.Competency.title}</label>
                      <div className="assessment_label">
                        {item.assessments.Competency.match && item.assessments.Competency.match.map((subItem, index) => {
                          return (
                            <span title={subItem} key={index}>#{subItem}</span>
                          )
                        })}
                      </div>
                    </div>
                  </li>
                  <li className={`assessment_item ${item.labels.length > 0 ? '' : 'hide'}`}>
                    <div className="same-kill">
                      <span>相同技能</span>
                    </div>
                    <div className="kills-container">
                      <div className="kills">
                        {item.labels.map((subItem, subIndex) => {
                          return (
                            <span key={subIndex + '0'}>{subItem.LabelName}</span>
                          )
                        })}
                      </div>
                      <div className={`same-kill__more ${item.labels.length > 4 ? '' : 'hide'} `} onMouseOver={this.showMoreKills.bind(this)} onMouseOut={this.hideMoreKills.bind(this)}>
                        <span className="more_kills">更多>></span>
                        <div className="more-kill-area hide">
                          <div className="content">
                            {item.labels.map((subItem, subIndex) => {
                              return (
                                <span key={subIndex + '1'}>{subItem.LabelName}</span>
                              )
                            })}
                          </div>
                        </div>
                      </div>
                    </div>
                  </li>
                  <li className="other_info">
                    <span title={item.job ? item.job + '/' + item.phase : ''}>{item.job ? item.job + '/' + item.phase : ''}</span>
                  </li>
                </ul>
              </li>
            )
          })}
        </ul>
        <div className={`no-data ${this.props.dataSource.length === 0 ? '' : 'hide'} `} >
              暂无数据
        </div>
      </div>
    )
  }
}
