import React, { Component } from 'react'
import BaseComponent from '../BaseComponent'
import baseComponent from '&/vender/base-component'
import './flipbuttons.scss'

export default class FlipButtons extends baseComponent {
	static defaultProps = {
		arrowNames: ['', ''],
		dataSource: [],
		isAddSub: true
	}

	constructor (props) {
		super(props)
		this.state = {
			init: true,
			isEditSub: false,
			id: props.id
		}
	}

	static getDerivedStateFromProps(nextProps, prevState) {
		return { id: nextProps.id, isEditSub: ((nextProps.id === prevState.id) && !prevState.init) }
	}

	onAddClickHandler = (e) => {
		this.props.onAddOpinions && this.props.onAddOpinions()
	}

	onArrowClickHandler = (e) => {
		if (this.props.hideArrows) {
			return
		}
		let dircetion = ''
		if (e.currentTarget.className.includes('arrow-left')) {
			dircetion = 'pre'
		}else if (e.currentTarget.className.includes('arrow-right'))  {
			dircetion = 'next'
		}
		this.props.onArrowClick && this.props.onArrowClick(dircetion)
	}

	onButtonClickHandler = (data) => {
		!this.props.disable && this.props.onButtonClick && this.props.onButtonClick(data)
	}

	onSubEditHandler = (e) => {
		e.stopPropagation()
		this.props.onSubEditHandler && this.props.onSubEditHandler()
	}

	render () {
		return <div className={`flipbuttons-container ${this.props.disable ? 'disable' : ''}`}>
			<div className={`arrow-left ${this.props.hideArrows ? 'hide' : ''}`} onClick={this.onArrowClickHandler}>
				<span className='arrow-left-icon'></span>
				<span className='arrow-left-txt'>{this.props.arrowNames[0]}</span>
			</div>
			<div className='buttons-container'>
				{this.props.disable && <span className='button-disable-reason'>{this.props.disableReason || ''}</span>}
				{
					this.props.dataSource.map((data, index) => {
						return <span key={index} className={`button ${data['className']} ${data['status'] === this.props.activeStatus ? 'active' : ''}`} onClick={this.onButtonClickHandler.bind(this, data)}>{data['name']}</span>
					})
				}
				{
					this.props.isAddSub && !this.state.isEditSub && !!!this.props.subscript && <span className='addBtn'><span className='addBtn-icon' onClick={this.onAddClickHandler}></span><span className='addBtn-txt'>附加筛选意见</span></span>
				}
				{
					this.state.isEditSub || !!this.props.subscript && <span className='sub'>
						<span className='sub-pointer'>
							<span className='sub-tip'>{this.props.subscript}</span>
							<span className='sub-txt'>{this.props.subscript}</span>
						</span>
						<span className='sub-icon' onClick={this.onSubEditHandler}></span>
					</span>
				}
			</div>
			<div className={`arrow-right ${this.props.hideArrows ? 'hide' : ''}`} onClick={this.onArrowClickHandler}>
				<span className='arrow-right-txt'>{this.props.arrowNames[1]}</span>
				<span className='arrow-right-icon'></span>
			</div>
		</div>
	}
}
