import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import ButtonGroup from './ButtonGroup';
import ButtonItem from './ButtonItem';
require('./index.scss');

export default class extends BaseComponent {
    constructor(props) {
		super(props);
        this.dataSource = this.formatMeta(props.dataSource);
        
	}
    /**
    * 如果数据是平级需要分好组，每组最多可放置this.props.maxLen个按钮
    */
    formatMeta(metadata) {
        let returnArr = [];
        let groupArr = [];
        let flag = false;
        let count = 0 ;
        metadata.forEach((data, index) => {
            const beforeData = groupArr[groupArr.length - 1];
            if(!beforeData || beforeData.group === data.group) {
                if(flag) {//本组元素如果超过this.props.maxLen则不添加
                    return;
                }
                if(groupArr.length >= (this.props.maxLen || Number.POSITIVE_INFINITY)) {
                    flag = true;
                    groupArr.push({text: '更多', icon: 'arrow', group: beforeData.group});
                    return;
                }
                groupArr.push(data);
            }else {
                console.log(123);
                flag = false;
                returnArr.push(groupArr);
                groupArr = [];
                groupArr.push(data);
            }
       
        });
        returnArr.push(groupArr);
        return returnArr;
    }

    render () {
        let subArr = [];
        console.log(this.dataSource)
        return (<div className='buttonbar-container'>
                    {
                        this.dataSource.map((item, index) => {
                            subArr = [];
                            item.forEach(data => {
                                subArr.push(<ButtonItem {...data}/>);
                            });

                            return (<ButtonGroup key={index}>
                                        {subArr}
                                    </ButtonGroup>);
                        })
                    }
                </div>);
    }
}