import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import Card from '../card';
require ('./Colorfulspan.scss');

export default class extends BaseComponent{
    constructor(props) {
        super(props);
        this.handleenter = this.handleenter.bind(this);
        this.handleout = this.handleout.bind(this);

        this.colorList = ['Lightblue','Weightblue','Orange','Banana','Purple'];
        this.count = 0;
        this.skc = '';
        this.state = {dataSource: [], tipDataSource: []};//截取dataSource
    }

    componentDidMount(){
      const colorSpanList = Array.prototype.slice.call(document.getElementsByClassName('colortag'));
      if(colorSpanList){
        let totalNum = 0;//总个数
        let size = 0;//长度
        let rowSize = 1;//总行数，目前业务规定不能超过2行
        let tipList = [];
        colorSpanList.forEach((colorSpan, index) => {
            tipList.push(this.props.dataSource[index].text);

            const colorWidth = colorSpan.offsetWidth + 5;//margin:5
            if(size + colorWidth <= this.refs.colortagcontainer.offsetWidth){
                size += colorWidth;
            }else {
              rowSize ++;
              size = 33 + colorWidth;//33: 省略号元素的宽度
            }
            rowSize <= 2 && totalNum ++;
        })
        if(totalNum < colorSpanList.length) {
            this.setState({dataSource: this.props.dataSource.slice(0,totalNum), tipDataSource: {flas: '5', tips: tipList}})
        }
      }
    }

    componentDidUpdate(prevProps, prevState) {
        this.componentDidMount();
    }

    handleenter() {
        this.refs.card.handleEnter();
    }

    handleout() {
        this.refs.card.handleOut();
    }

    render() {
        this.count = 0;
        this.dataSource = this.state.dataSource.length > 0 ? this.state.dataSource : this.props.dataSource;
        let bodclass = '';
        if(!this.props.Spanposition){
            bodclass = "Colorfulspan_bod_c"
        }
        else if( this.props.Spanposition == 'l'){
            bodclass = "Colorfulspan_bod_l"
        }
        else if (this.props.Spanposition == 'r'){
            bodclass = "Colorfulspan_bod_r"
        }
        return (
            <div className={`colortag-container ${bodclass}`} ref='colortagcontainer'>
                <div className='content'>
                {
                    this.dataSource.map((ele, index) => {
                        if(!ele.inco){
                            let point = index;
                            if(point >= this.colorList.length){
                                point = index - this.colorList.length;
                            }
                            return (
                                <span key={index}
                                      className={`colortag ${this.colorList[point]} ${this.props.Spanposition ? this.props.Spanposition : ''}`}
                                      >
                                      {ele[this.props.fieldName || 'text']}
                                </span>
                            );
                        }else{
                            if(this.props.Spanposition){
                                this.skc = `SingleColor` + ` ` +this.props.Spanposition;
                            }
                            else{
                                this.skc =`SingleColor`
                            }
                            return (
                                <span key={index} className={this.skc}><span>{ ele[this.props.fieldName || "text"]}</span></span>
                            );
                        }
                    })
                }
                {this.state.dataSource.length > 0 ? 
                    <span className='ellipsis'
                          onMouseOver={this.handleenter}
                          onMouseOut={this.handleout}
                          >
                          <span className ='dingwei'>{'···'}</span>
                          <Card ref='card' dataSource={this.state.tipDataSource}/>
                    </span> : null
                }
                </div>
            </div>
        );
    }
}
