import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import './index.scss';

const WEEKDAY_CN = {
  '0': '日',
  '1': '一',
  '2': '二',
  '3': '三',
  '4': '四',
  '5': '五',
  '6': '六'
};
export default class extends BaseComponent{
  static defaultProps = {
    mainColor: '#12abc9',
    ghostColor: '#fff'
  };

  constructor(props) {
    super(props);
    this.state = {
      ...this.getDateTime(new Date())
    };
    setInterval(() => {
      this.setState({
        ...this.getDateTime(new Date())
      });
    }, 1000);
  }

  getDateTime(date) {

    let tempArray = [date.getMonth() + 1, date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds()];
    let formatArray = tempArray.map((itm) => {
      return itm >= 10 ? itm : '0' + itm;
    });
    return {
      year: date.getFullYear(),
      month: formatArray[0],
      day: formatArray[1],
      weekday: WEEKDAY_CN[date.getDay()],
      hours: formatArray[2],
      minutes: formatArray[3],
      seconds: formatArray[4]
    };
  }

  render() {
    const { mainColor, ghostColor } = this.props;
    const { year, month, day, weekday, hours, minutes, seconds } = this.state;
    return (
      <div className="bs-date-time-view" style={{ borderColor: mainColor, color: mainColor }}>
        <span className="bs-date-time-view-date">{year}年{month}月{day}日</span>
        <span className="bs-date-time-view-week">星期{weekday}</span>
        <span
          className="bs-date-time-view-time"
          style={{ background: mainColor, color: ghostColor }}>
          {hours}:{minutes}:{seconds}
        </span>
      </div>
    );
  }
}
