import * as React from 'react';
import BaseToolbarItem from '../baseToolbarItem';

export default class Eraser extends BaseToolbarItem {
  draw(canvas: HTMLCanvasElement, startPoint: { x: number; y: number }, event: any): void {
    const canvasContext = canvas.getContext('2d');
    if (!!canvasContext) {
      canvasContext.clearRect(event.offsetX, event.offsetY, 12, 12);
      canvasContext.stroke();
    }
  }

  render() {
    return (
      <div className="doodle-board-toolbar-item-eraser">
        <svg className="icon" aria-hidden="true">
          <use xlinkHref="#icon-xiangpica"/>
        </svg>
      </div>
    );
  }
}

