import * as React from 'react';
import BaseToolbarItem from '../baseToolbarItem';

export default class Rectangle extends BaseToolbarItem {

  draw(canvas: HTMLCanvasElement, startPoint: { x: number; y: number }, event: any): void {
    const canvasContext = canvas.getContext('2d');
    if (!!canvasContext) {
      let width = event.offsetX - startPoint.x;
      let height = event.offsetY - startPoint.y;
      let x, y;
      if (width > 0) {
        x = startPoint.x;
      } else {
        x = event.offsetX;
      }

      if (height > 0) {
        y = startPoint.y;
      } else {
        y = event.offsetY;
      }
      canvasContext.clearRect(0, 0, canvas.width, canvas.height);
      canvasContext.putImageData(this.props.mainContext.getLatestImageData(), 0, 0);
      canvasContext.strokeRect(x, y, Math.abs(width), Math.abs(height))
    }
  }

  render() {
    return (
      <div className="doodle-board-toolbar-item-brush">
        <svg className="icon" aria-hidden="true">
          <use xlinkHref="#icon-Rectangle1"/>
        </svg>
      </div>
    );
  }
}

