const uiList: Array<UIItem> = [];
let uuid = 0;

function generateId() {
  return (function () {
    return ++uuid;
  }())
}


export interface UIItem {
  id: number,
  uiName: string,
  uiClass: any,
  isClick: boolean
}

export function registerUI(uiName: string, uiClass: any, isClick: boolean = false) {
  uiList.push({
    id: generateId(),
    uiName,
    uiClass,
    isClick
  })
}

export function getUIList(): Array<UIItem> {
  return uiList;
}
