import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import Search from '../search';
require('./index.scss');

export default class extends BaseComponent {
    static defaultProps = {
        dataSource: [],
        isShowArrow: true, //是否显示箭头
    }

    constructor(props) {
		super(props);
        this.onClickHandler = this.onClickHandler.bind(this);
        this.onBodyClick = this.onBodyClick.bind(this);
        this.onSearchChange = this.onSearchChange.bind(this);

        this.state = {
            isShowShade: false //是否有遮罩
        }
	}

    onClickHandler(e) {
        this.props.dropdownClose && this.props.dropdownClose(this.props.index);
        this.point && (this.point.className = this.point.className.match('down') ? 'point' : 'point down');
        this.bodyDom && (this.bodyDom.className = this.bodyDom.className.match('down') ? 'body' : 'body down');
        this.arrowDom && (this.arrowDom.className = this.arrowDom.className.match('down') ? 'arrow' : 'arrow down');
        this.searchDom && (this.searchDom.className = this.searchDom.className.match('down') ? 'search-area' : 'search-area down');
        this.setState({isShowShade: !!this.bodyDom.className.match('down')});
    }

    onBodyClick(e) {
        e.stopPropagation();
    }

    onSelectHandler(obj, e) {
        this.dropdownClose();
        this.props.dataSource.find(item => {
            if(item[this.props.fieldName] === obj[this.props.fieldName]) {
                item.selected = true;
            }else {
                item.selected = false;
            }
            return null;
        });
        this.setState({isShowShade: false}, () => {
            this.props.onChange && this.props.onChange(obj);
        });
    }

    onSearchChange(searchValue) {
        console.log(searchValue);
    }

    dropdownClose() {
        this.point && (this.point.className.match('down') ? this.point.className =  'point' : null);
        this.bodyDom && (this.bodyDom.className.match('down') ? this.bodyDom.className = 'body' : null);
        this.arrowDom && (this.arrowDom.className.match('down') ? this.arrowDom.className = 'arrow' : null);
        this.searchDom && (this.searchDom.className.match('down') ? this.searchDom.className = 'search-area' : null);
    }

    render () {
      const selectItem = this.props.dataSource.find((item) => {return item.selected});

      return (<div className='dropdown-container' onClick={this.onClickHandler}>
                {this.state.isShowShade ? <div className='shade'/> : null}
      			<input className='content' readOnly value={selectItem && selectItem[this.props.fieldName] || ''}/>
                <span className='dropdown__arrow' />
                {this.props.isShowArrow ? <span className='point' ref={point => {this.point = point;}}></span> : null}
                <div className='body' ref={body => {this.bodyDom = body;}} onClick={this.onBodyClick}>
                    {this.props.isShowArrow ? <span className='arrow' ref={arrow => {this.arrowDom = arrow;}}></span> : null}
                    {
                        this.props.isShowSearch ? <div className='search-area' ref={search => {this.searchDom = search;}}>
                            <Search onChangeHandler={this.onSearchChange}/>
                        </div> : null
                    }
                    <ul className='list'>
                        {
                            this.props.dataSource.map((data, index) => {
                                return <li key={index} onClick={this.onSelectHandler.bind(this, data)}>{data[this.props.fieldName]}</li>;
                            })
                        }
                    </ul>
                </div>
    		  </div>);
    }
}