import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import Dropdown from '../dropdown/index';
require('./index.scss');

export default class extends BaseComponent {
    constructor(props) {
		super(props);
        this.dropdownClose = this.dropdownClose.bind(this);
	}

    onItemClickHandler(index,item) {
        this.props.onItemClickHandler && this.props.onItemClickHandler(...arguments);
    }

    dropdownClose(index) {
        this.props.dataSource.forEach((item,point) => {
            point !== index ? this.refs[`dropdown${point}`].dropdownClose() : null;
        })
    }

    render () {
      return (
            <div className='dropdownconnection-container'>
                {
                    this.props.dataSource.map((data, index) => {
                        return <Dropdown key={index}
                                         ref={`dropdown${index}`}
                                         index={index}
                                         dataSource={data.list}
                                         fieldName={data.fieldName}
                                         isShowSearch={data.isShowSearch}
                                         onItemClickHandler={this.onItemClickHandler.bind(this,index)}
                                         dropdownClose={this.dropdownClose.bind(this)}
                                         />
                    })
                }
            </div>
            );
    }
}