import React, { Component } from 'react'
import BaseComponent from '../BaseComponent'
import Hurdle from '&/components/hurdle'
require('./specialheader.scss');
export default class SpecialHeader extends BaseComponent {
  static defaultProps = {
    isAddTag: false
  }
  constructor(props) {
    super(props);
    this.remarkRef = React.createRef()
  }
  /**
   * 重复简历图标点击
   */
  onClickRepeat = (e) => {
    e.preventDefault();
    e.stopPropagation();
    this.props.onClickRepeat && this.props.onClickRepeat();
  }
  inputFocusHandler = (e) => {
    if (this.remarkRef.current.style.right !== '0px') {
      this.remarkRef.current.style.setProperty('right', 0)
    }
  }
  inputBlurHandler = (e) => {
    // this.remarkRef.current.style.setProperty('right', '-1000px')
  }
  hiddenRemarkDetail = () => {
    let editorDom = document.getElementsByClassName('mention-editor')[0]
    let selectlistDom = document.getElementsByClassName('selectlist-container')
    let focusClass = 'mention-editor-focus'
    if (editorDom && editorDom.className.indexOf(focusClass) < 0 && selectlistDom.length === 0) {
      this.remarkRef.current.style.setProperty('right', '-1000px')
      // this.hurdleRef.refs.popconfirm.onCancel()
      let delBtnDom = [].slice.call(document.getElementsByClassName('ant-popover-open'));
      if (delBtnDom.length) {
        delBtnDom[0].click()
      }
    }
  }
  hideRemarkPop = (e) => {
    // 判断真正发生事件的DOM元素是否是备注弹框里边的元素，
    // 点击弹框外边的地方才让备注弹框隐藏

    // 判断是否点击删除的二次确认弹框
    let popDom = document.getElementsByClassName('ant-popover')
    let clickPop = false
    if (popDom && popDom[0] && popDom[0].innerHTML.indexOf(e.target.className) > -1) {
      clickPop = true
    }
    // 条件：如果不是点击备注浮层里 && 不是点击删除按钮 && 不是点击删除的二次确认弹框 && 不是点击选人控件
    if (this.remarkRef.current.innerHTML.indexOf(e.target.className) < 0
      && e.target.className.indexOf('deleteBtn') < 0
      && !clickPop
      && e.target.className.indexOf('selectlist') < 0) {
      this.remarkRef.current.style.setProperty('right', '-1000px')
    }
  }
  componentDidMount() {
    document.body.addEventListener('click', this.hideRemarkPop);
  }

  render() {
    return (
      <div className='header-special-container'>
        <div className='header-inner'>
          <div className='left-info'>
            {!this.props.isHideInfo && <div className='base-info'>
              <span className='base-info-label'>{this.props.dataSource.applyInfo[0]['label']}：</span><span className='base-info-name'>{this.props.dataSource.applyInfo[0]['value']}</span>
              <span className='base-info-label'>{this.props.dataSource.applyInfo[1]['label']}：</span><span className='base-info-name'>{this.props.dataSource.applyInfo[1]['value']}</span>
            </div>}
            <div className='content-container'>
              <div className="icon-group">
                {this.props.dataSource.isRepeat ? <span className="icon isRepeat" onClick={this.onClickRepeat} /> : null}
                {this.props.dataSource.isInterRec ? <span className="icon isInterRec">
                  {(this.props.dataSource.internalTips.length > 0 && this.props.isShowTip) && <div className="internal-tip"><span className="arrow"/><ul className="content">
                    {
                      this.props.dataSource.internalTips.map((internal, index) => {
                        return <li key={index} className="row"><span className="field">{internal['field']}</span><span>{internal['value']}</span></li>;
                      })
                    }
                  </ul></div>}
                </span> : null}
                {this.props.dataSource.isHunter ? <span className="icon isHunter">
                  {(this.props.dataSource.hunterTips.length > 0 && this.props.isShowTip) && <div className="hunter-tip"><span className="arrow"/><ul className="content">
                    {
                      this.props.dataSource.hunterTips.map((hunter, index) => {
                        return <li key={index} className="row"><span className="field">{hunter['field']}</span><span>{hunter['value']}</span></li>;
                      })
                    }
                  </ul></div>}
                </span> : null}
                {this.props.isNoContact &&
                  <span className="icon isNocontact">
                    <div className="nocontact-tip">
                      <span className="arrow"/>
                      <span className="">手机号，邮箱缺失</span>
                    </div>
                  </span>
                }
                {this.props.isExternalRec &&
                  <span className="icon isExternalRec"/>
                }
              </div>
              <div className="detail">
                <span className="name">{this.props.dataSource.name}</span>
                <span className="id">{this.props.dataSource.id}</span>
                <span className='status'>
                  <span className='status-tip'><span className='status-tip-txt'>{this.props.dataSource.status}</span></span>
                  <span className='status-txt'>{this.props.dataSource.status}</span>
                </span>
              </div>
              <div className="tag-down">
                {this.props.isAddTag && <span className={`addTag-btn ${!!!this.props.tagList.length && 'single'}`} onClick={this.addTagHandler} />}
                {
                  this.props.tagList.slice(0, 4).map((tag, index) => {
                    return <span key={index} index={index} className={`tag type${tag['LabelType']}`}>
                      {tag['LabelName']}
                    </span>;
                  })
                }
                {
                  this.props.tagList.length > 4 &&
                  <span className="tag-more">
                    <div className="taglist">
                      {
                        this.props.tagList.slice(4).map((tag, index) => {
                          return <span key={index} index={index + 4} className={`tag type${tag['LabelType']}`}>
                            {tag['LabelName']}
                          </span>;
                        })
                      }
                    </div>
                  </span>
                }
              </div>
            </div>
          </div>
          <div className='right-fun' onMouseEnter={this.inputFocusHandler}>
              <div className='remark-content'>{`${this.props.remark.title} (${this.props.remark.remarksCount})`}</div>
              {
                  <div className='remark-detail' ref={this.remarkRef} onMouseLeave={this.hiddenRemarkDetail}>
                    <Hurdle 
                            ref={el => this.hurdleRef = el}
                            {...this.props}
                            title={this.props.remark.title}
                            fieldName={this.props.remark.fieldName}
                            fieldValue={this.props.remark.fieldValue}
                            canDeleteFieldName={this.props.remark.canDeleteFieldName}
                            remarksCount={this.props.remark.remarksCount}
                            operation='添加'
                            isEdit={true}
                            reduceHeight='100%'
                            getUserList={this.props.getUserList}
                            dataSource={this.props.remark.remarkDataList}
                            addHandler={this.props.onAddRemark}
                            removeHandler={this.props.onRemoveRemark}
                            inputFocusHandler={this.inputFocusHandler}
                            inputBlurHandler={this.inputBlurHandler}
                            scrollBottomHandler={this.props.scrollBottomHandler}
                            belongPage='resumeFilter'
                            />
                  </div>
              }
          </div>
        </div>
      </div>
    );
  }
}
