import React,{ Component } from 'react';
import BaseComponent from '../BaseComponent';
import Smallspan from '../smallspan';
import * as formVerify from '../form/formVerify';
require('./HiName.scss');

export default class extends Component {
    constructor(props){
        super(props);
        this.handleExEdit = this.handleExEdit.bind(this);
        this.handleSubmit = this.handleSubmit.bind(this);
        this.onKeyUpHandler = this.onKeyUpHandler.bind(this);
        this.onBlurHandler = this.onBlurHandler.bind(this);

        this.tempdata = JSON.parse(JSON.stringify(props.dataSource));
        this.state = {
            text: props.dataSource.text,
            isEdit: false,
            error: false,
            errorMessage: ''
        };
    }

    handleSubmit() {
        this.setState({isEdit: false, text: JSON.parse(JSON.stringify(this.tempdata.text))});
        return this.tempdata.text;
    }

    handleExEdit(isEdit) {
        this.tempdata = JSON.parse(JSON.stringify(this.props.dataSource));
        this.setState({isEdit: isEdit, error: false, errorMessage: '', text: this.props.dataSource.text});
    }

    onKeyUpHandler(e) {
        //目前名字规则只存60个字符
        this.setState({text: e.target.value}, () => {
            this.tempdata.text = this.state.text;
        })
    }

    onBlurHandler(e) {
        const message = formVerify.verify(e.target.value, this.props.dataSource['rule']);
        if(message) {
            this.setState({error: true, errorMessage: message});
        }else {
            this.state.error && this.setState({error: false, errorMessage: ''});
        }
        this.props.formErrorNotify && this.props.formErrorNotify(!!message);
    }
    
    render() { 
        return (
            <div className ='head-container'>
                <Smallspan dataSource={this.props.dataSource.spanmessage} isShowSmallTips={this.props.isShowSmallTips}/>
                <img className='photo' src={this.props.dataSource.url}/>
                <input className={`in${this.state.isEdit && ' edit' || ' readonly'}${this.state.error ? ' error': ''}`}
                       readOnly={this.state.isEdit ? false : 'readOnly'}
                       onChange={this.onKeyUpHandler}
                       onBlur={this.onBlurHandler}
                       value={this.state.text}/>
                {this.state.error ? <div className='message' ref='message'>{this.state.errorMessage}</div> : null}
            </div>
        )
    }
}


