import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import Subentry from '../subentry/index';
import Colortips from '../colortips';
require('./index.scss');

export default class Hurdle extends BaseComponent {
    static defaultProps = {
        isEdit: true,
        dataSource: []
    }

	constructor(props) {
    super(props);
    this.deleteRecordHandler = this.deleteRecordHandler.bind(this)
  }

  componentDidMount () {
    this.gradientDisplay()
    //this.setContentMaxHeight()
    //window.addEventListener('resize', this.setContentMaxHeight)
  }

  componentDidUpdate () {
    this.gradientDisplay()
    //this.setContentMaxHeight()
  }

  componentWillUnmount () {
    this.gradientDisplay()
    //window.removeEventListener('resize', this.setContentMaxHeight)
  }
  
  handleSubentryFocusChange = () => {
    this.props.inputFocusHandler && this.props.inputFocusHandler()
    //this.setContentMaxHeight()
  }

  handleSubentryBlurChange = () => {
    this.props.inputBlurHandler && this.props.inputBlurHandler()
    //this.setContentMaxHeight()
  }

  deleteRecordHandler (ele, e) {
    this.props.removeHandler && this.props.removeHandler(ele)
  }
  gradientDisplay = () => {
    const childHeight = this.refs.record0 ? this.refs.record0.offsetHeight * this.props.dataSource.length : 0
    if(this.refs.content.offsetHeight >= childHeight) {
      this.refs.gradient.style.display = 'none'
    }else {
      this.refs.gradient.style.display = 'block'
    }
  }
  contentScrollHandler = e => {
    const scrollDom = e.target
    if(scrollDom.scrollTop >= scrollDom.scrollHeight - scrollDom.clientHeight) {
      this.refs.gradient.style.display != 'none' && (this.refs.gradient.style.display = 'none')
    }else {
      this.refs.gradient.style.display != 'block' && (this.refs.gradient.style.display = 'block')
    }
  }

  render () {
    return (<div className='hurdle-container'>
              <Subentry title={this.props.title}
                        num={this.props.dataSource.length}
                        fieldName={this.props.fieldName}
                        fieldValue={this.props.fieldValue}
                        isEdit={this.props.isEdit}
                        addHandler={this.props.addHandler}
                        placeholder={this.props.placeholder}
                        ref='subentry'
                        onFocusChange={this.handleSubentryFocusChange}
                        onBlurChange={this.handleSubentryBlurChange}
                        >
                <div className='content' onScroll={this.contentScrollHandler} ref='content'>
                  {
                      !this.props.isEdit && this.props.dataSource.length === 0 ? <div className='nulldata'><span className='content'><span className='icon air'></span><span className='txt'>这里什么都没有...</span></span></div> :
                      this.props.dataSource.map((item, index) => {
                        return <div className='record' key={index} ref={`record${index}`}>
                                  <div className='record-content'>
                                    <span className='title'>
                                      <span className='txt'>{`${item[this.props.fieldName] || ''}: `}</span>
                                      <span className='date'>{item['CreateDate'].split(' ')[0]}</span>
                                    </span>
                                    <div className='sub'>
                                        <pre>{item[this.props.fieldValue] || ''}</pre>
                                        {this.props.isEdit && (item[this.props.canDeleteFieldName]) && <span className='delete' onClick={this.deleteRecordHandler.bind(this, item)}>删除</span>}
                                    </div>
                                  </div>
                                </div>
                      })
                  }
                </div>
                <div className='gradient' ref='gradient'></div>
              </Subentry>
    </div>);
  }
}
