import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import Subentry from '../subentry/index';
import Colortips from '../colortips';
import Tooltip from 'antd/lib/tooltip';
import Popconfirm from 'antd/lib/popconfirm'
require('antd/lib/tooltip/style/css')
require('antd/lib/popconfirm/style/css')
require('./index.scss');
export default class extends BaseComponent {
  static defaultProps = {
      isEdit: true,
      dataSource: [],
      mode: 'base' // 直接收base 和 big
  }

	constructor(props) {
    super(props);
    this.deleteRecordHandler = this.deleteRecordHandler.bind(this)
    this.subentry = React.createRef()
    this.content = React.createRef()
    this.isRender = true
    this.isDisplayReplyBtn = this.props.isDisplayReplyBtn !== undefined ? this.props.isDisplayReplyBtn : true
  }

  shouldComponentUpdate (nextProps, nextState) {
    if (JSON.stringify(this.props.dataSource) !== JSON.stringify(nextProps.dataSource)) {
      this.isRender = true
    }
    this.props.mode !== 'big' && this.setContentMaxHeight()
    return this.isRender ? true : false
  }

  componentDidMount () {
    this.props.mode !== 'big' && this.setContentMaxHeight()
    window.addEventListener('resize', this.props.mode !== 'big' ? this.setContentMaxHeight : null)
  }

  componentDidUpdate () {
    if (!this.props.isScroll && !this.isRemove) {
      this.content.current.scrollTop = 0
    } else if(this.isRemove) {
      this.content.current.scrollTop = this.scrollTop || 0
      this.isRemove = false
    }
    this.props.mode !== 'big' && this.setContentMaxHeight()
  }

  componentWillUnmount () {
    window.removeEventListener('resize', this.setContentMaxHeight)
  }

  getQueryString = (item) => {
    var svalue = location.href.match(new RegExp('[?&]' + item + '=([^&#]*)(&?)', 'i'))
    return svalue ? svalue[1] : svalue
  }

  isElink = () => {
    // 判断isElink添加newShow兼容
    var entryPageId = window.BSGlobal ? window.BSGlobal.entryPageId : ''
    return entryPageId.indexOf('applicants/show?type=Elink') >= 0 || entryPageId.indexOf('applicants/newShow?type=Elink') >= 0
  }

  isCheckResume = () => {
    var AppPersons = JSON.parse(sessionStorage.getItem('checkApplications'))
    var checkUrl = this.getQueryString('checkApp')
    var dom = document.getElementsByClassName('default button')
    if (checkUrl && AppPersons) {
      if (dom && dom.length === 0) {
        return false
      }
      return true
    }
    return false
  }

  setContentMaxHeight = () => {
    if (!this.props.belongPage || this.props.belongPage !== 'resumeFilter') {
      this.content.current.style.height = '0px'
      const winHeight = document.documentElement.clientHeight || document.body.clientHeight
      const offsetObj = this.content.current.getBoundingClientRect()
      const offsetHeight = this.content.current.offsetHeight
      const scrollHeight = this.content.current.scrollHeight
      const offsetBottom = winHeight - (offsetObj.top + offsetHeight)
      this.content.current.style.maxHeight = `${offsetBottom}px`
      this.content.current.style.height = `${scrollHeight}px`
    }
  }
  
  handleSubentryFocusChange = () => {
    //this.setContentMaxHeight()
    this.props.inputFocusHandler && this.props.inputFocusHandler()
  }

  handleSubentryBlurChange = () => {
    //this.setContentMaxHeight()
    this.props.inputBlurHandler && this.props.inputBlurHandler()
  }

  deleteRecordHandler (ele, e) {
    this.isRemove = true
    this.scrollTop = this.content.current.scrollTop
    this.props.removeHandler && this.props.removeHandler(ele)
  }
  
  contentScrollHandler = e => {
    const scrollDom = e.target
    if(scrollDom.scrollTop >= scrollDom.scrollHeight - scrollDom.clientHeight) { // 滚动到底部了
      this.refs.gradient.style.display != 'none' && (this.refs.gradient.style.display = 'none')
      this.props.scrollBottomHandler && this.props.scrollBottomHandler()
    }else {
      this.refs.gradient.style.display != 'block' && (this.refs.gradient.style.display = 'block')
    }
  }

  renderTip = (item) => {
    if (!item.JobId) {
      return <span style={{ fontSize: '12px' }}>在所有应聘资料添加</span>
    }
    return <div className='job-tip'>
        <div className='tip-row'>
          <label className='tip-key'>职位名称：</label>
          <span className='tip-value'>{item['JobName']}</span>
        </div>
        <div className='tip-row'>
          <label className='tip-key'>阶段状态：</label>
          <span className='tip-value'>{`${item['PhaseName']}（${item['StatusName']}）`}</span>
        </div>
    </div>
  }

  replyHandler = (ele, e) => {
    ele.RemarkContentFormat = ele.RemarkContentFormat.replace('"IsReply":false', '"IsReply":true')
    const content = JSON.parse(ele.RemarkContentFormat)[0]
    this.subentry.current.replyHandler({Id: ele['CreateBy'], Name: ele['CreateByName'], name: `回复 @${ele['CreateByName']}（${ele['UserEmail']}）`, Email: ele['UserEmail'], IsReply: true, replyRemarkId: ele['Id'], isPrivate: ele['RemarkStatus']})

  }
  render () {
    this.isRender = false
    return (<div className='hurdle-container'>
              <Subentry 
                        {...this.props}
                        title={this.props.title}
                        saveTitle={this.props.mode === 'base' ? '保存' : '添加'}
                        isDisplayHeader={this.props.mode === 'base'}
                        num={this.props.remarksCount}
                        fieldName={this.props.fieldName}
                        fieldValue={this.props.fieldValue}
                        isEdit={this.props.isEdit}
                        addHandler={this.props.addHandler}
                        ref={this.subentry}
                        getUserList={this.props.getUserList}
                        onFocusChange={this.handleSubentryFocusChange}
                        onBlurChange={this.handleSubentryBlurChange}
                        openRemarkPop={this.props.openRemarkPop}
                        isShowOpenRemarkPopBtn={this.props.isShowOpenRemarkPopBtn}
                        userTotal={this.props.userTotal}
                        isDisplayPrivateBtn={this.props.isDisplayPrivateBtn}
                        >
                <div className='content' onScroll={this.contentScrollHandler} ref={this.content}>
                  <div>
                    <pre>
                  {
                      !this.props.isEdit && this.props.dataSource.length === 0 ? <div className='nulldata'><span className='content'><span className='icon air'></span><span className='txt'>这里什么都没有...</span></span></div> :
                      this.props.dataSource.map((item, index) => {
                        return <div className='record' key={index}>
                                  <div className='record-content'>
                                    <span className='title'>
                                      <span className='title-txt'>
                                        <span className={`title-txt-name ${!!!item['StaffStatus'] ? 'stop' : ''}`}>{`${item[this.props.fieldName] || ''}`}</span>
                                        <span className='title-txt-status'>{`${!!!item['StaffStatus'] ? '（已停用）' : ''} :`}</span>
                                      </span>
                                      <span className='title-right'>
                                      {item['RemarkStatus'] && <span className='title-right-private'><span className='title-right-private-icon'/><span>私密</span></span>}
                                      {
                                        this.props.mode === 'base' ? <Tooltip placement='topLeft' arrowPointAtCenter={true} title={this.renderTip(item)}>
                                          <span className='title-right-tip'></span>
                                        </Tooltip> : <span className='sub-footer-date'>{item['CreateDate']}</span>
                                      }
                                      </span>
                                    </span>
                                    <div className='sub'>
                                        <div className='sub-content'>
                                          {
                                            JSON.parse(item['RemarkContentFormat']).map((content, index, array) => {
                                              // debugger
                                              const name = content['UserName']
                                              const email = content['Email']
                                              const isReply = content['IsReply']
                                              if (name) {
                                                return <span className='sub-reply-content'>
                                                  {
                                                    isReply && <span className='sub-reply-content-reply'>回复</span>
                                                  }
                                                    <span className='sub-reply-content-user'>
                                                      <Tooltip title={ name + ' (' + email + ')' }>
                                                        <span className='sub-reply-content-name'>{`@${name} `}</span>
                                                      </Tooltip>
                                                    </span>
                                                    {
                                                      isReply && <span>:</span>
                                                    }
                                                    <span>{`${content['Content']}`}</span>
                                                  </span>
                                              } else {
                                                return <span>{`${content['Content']}`}</span>
                                              }
                                            })
                                          }
                                        </div>
                                        <div className='sub-footer'>
                                          {
                                            this.props.mode === 'base' ? <span className='sub-footer-date'>{item['CreateDate'].split(' ')[0]}</span> :
                                            <span className='sub-footer-date'>
                                              {
                                                !!item['JobId'] &&
                                                <span className='sub-footer-continer'>
                                                  <Tooltip title={ item['JobName'] }>
                                                    <span className='sub-footer-jobname'>{item['JobName']}</span>
                                                  </Tooltip>
                                                  <span className='sub-footer-separator'>|</span>
                                                  <Tooltip title={ item['PhaseName'] + '(' + item['StatusName'] + ')' }>
                                                    <span className='sub-footer-phase'>{`${item['PhaseName']}（${item['StatusName']}）`}</span>
                                                  </Tooltip>
                                                </span>
                                              }
                                              {
                                                !item['JobId'] &&
                                                <span className='sub-footer-continer'>在所有应聘资料添加</span>
                                              }
                                            </span>
                                          }
                                          <span className='sub-footer-button'>
                                            {(this.props.isEdit && this.isDisplayReplyBtn && !!item['StaffStatus']) && <span className='replyBtn' onClick={this.replyHandler.bind(this, item)}>回复</span>}
                                            {this.props.isEdit && (item[this.props.canDeleteFieldName]) &&
                                              <Popconfirm
                                                ref='popconfirm'
                                                placement="topLeft"
                                                arrowPointAtCenter={true}
                                                title="确定删除此条备注吗？"
                                                okText="是"
                                                cancelText="否"
                                                onConfirm={this.deleteRecordHandler.bind(this, item)}>
                                                <span className='deleteBtn'>删除</span>
                                              </Popconfirm>
                                            }
                                          </span>
                                        </div>
                                    </div>
                                  </div>
                                </div>
                      })
                  }
                  </pre>
                </div>
                <div className='gradient' ref='gradient'></div>
                </div>
              </Subentry>
    </div>);
  }
}