import React from 'react';
import BaseComponent from '../BaseComponent';
import DoodleBoard from '../doodle-board';
import AntdModal from '../antd-modal';
import './index.scss';

export default class ImagePreviewModal extends BaseComponent{
  static defaultProps = {
    visible: true,
    backdropImg: '',
    initBoardImg: '',
    onSave: () => {
    },
    onCancel: () => {
    }
  };

  render() {
    const { backdropImg, initBoardImg, onSave, onCancel, visible } = this.props;
    const Modal = (
      <AntdModal
        wrapClassName="imagepreview-modal"
        visible={true}
        bodyStyle={{ padding: 0 }}
        width="810px"
        footer={null}
        closable={false}
        zIndex={1102}
        maskStyle={
          { background: 'rgba(0,0,0,0)' }
        }
      >
        <DoodleBoard
          width={810}
          height={505}
          backdropImg={backdropImg}
          initBoardImg={initBoardImg}
          onSave={onSave}
          onCancel={onCancel}
        />
      </AntdModal>
    );
    return (
      <React.Fragment>
        {!!visible ? Modal : null}
      </React.Fragment>
    );
  }
}
