import React, { PureComponent } from 'react';
import Trigger from 'rc-trigger';
import placements from './placements';
import AntdTable from 'antd/lib/table';

export default class RelStore extends PureComponent {
  getPopupElement = () => {
    return (
      <div className="table-popup-wrapper talent-popup-wrapper">
        <div className="table-popup__arrow" ref={e => {
          this.arrowRef = e;
        }}
        />
        <AntdTable {...this.getTableProps()} />
      </div>
    );
  }
  getColumns = () => {
    return [
      {
        title: '人才库',
        dataIndex: 'StoreDBName',
        key: 'StoreDBName',
        width: 120
      },
      {
        title: '部门',
        dataIndex: 'StoreDBOrgName',
        key: 'StoreDBOrgName',
        width: 100,
        render: data => {
          return data || '-';
        }
      },
      {
        title: '上级人才库',
        dataIndex: 'StoreDBPName',
        key: 'StoreDBPName',
        width: 100,
        render: data => {
          return data || '-';
        }
      },
      {
        title: '储备时间',
        dataIndex: 'CreateDate',
        key: 'CreateDate',
        width: 90,
        render: CreateDate => {
          return _.formatDate(CreateDate);
        }
      },
      {
        title: '储备人',
        dataIndex: 'AddPersonName',
        key: 'AddPersonName',
        width: 100
      }
    ];
  }
  getTableProps = () => {
    return {
      className: 'table-module',
      size: 'small',
      dataSource: this.props.relStore,
      columns: this.getColumns(),
      pagination: false,
      scroll: { y: 160 },
      rowKey: 'StoreDBID'
    };
  }
  render() {
    return (
      <Trigger
        popupPlacement="bottom"
        action={['hover']}
        builtinPlacements={placements}
        popup={this.getPopupElement()}
        popupClassName={'rjc-popup-adjust'}
      >
        <span className="apply-info" key="rs">{this.props.relStore.length}个人才库</span>
      </Trigger>
    );
  }
}
