import React, { Component } from 'react';
import PropTypes from 'prop-types';
import BaseComponent from '../BaseComponent';
import AntdModal from '../antd-modal';
import Button from 'antd/lib/button';
import Checkbox from 'antd/lib/checkbox';
import Icon from 'antd/lib/icon';
import 'antd/lib/button/style/css';
import 'antd/lib/icon/style/css';
import 'antd/lib/checkbox/style/css';
import '../../assets/symbol';
import './index.scss';

export default class LicenseModal extends BaseComponent{
  constructor(props) {
    super(props);
    this.onOK = this.onOK.bind(this);
    this.onCancel = this.onCancel.bind(this);
    this.onChange = this.onChange.bind(this);
    this.state = {
      checkedTemp: this.props.isChecked,
      checked: this.props.isChecked
    };
  }

  onCancel() {
    this.setState({
      checkedTemp: this.state.checked
    }, function () {
      this.props.onCancel(this.state.checked);
    });
  }

  onOK() {
    if (!!this.props.onOK) {
      this.setState({
        checked: this.state.checkedTemp
      }, function () {
        this.props.onOK(this.state.checked);
      });
    }
  }

  onChange(v) {
    this.setState({
      checkedTemp: v.target.checked
    });
  }

  render() {
    const { title, content, visible, tips, readonly } = this.props;
    const { checkedTemp } = this.state;
    return (
      <AntdModal
        className="bs-license-modal"
        onCancel={this.onCancel}
        title={
          <div>
            <Icon type="question-circle" className="bs-license-modal-header__icon"/>
            <span className="bs-license-modal-header__title">{title}</span>
          </div>
        }
        visible={visible}
        footer={readonly ? null : <div className="bs-license-modal-footer">
          <Checkbox
            className="bs-license-modal-footer__checkbox"
            checked={checkedTemp}
            onChange={this.onChange}>{tips}</Checkbox>
          <Button onClick={this.onOK} type="primary" disabled={!checkedTemp}>
            确定
          </Button>
        </div>}>
        <div dangerouslySetInnerHTML={{ __html: content }}/>
      </AntdModal>
    );
  }
}

LicenseModal.propTypes = {};
