import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import PropTypes from 'prop-types';
require('./index.scss');

export default class MenuList extends BaseComponent {
  static defaultProps = {
    sourseList: [],
    setCurrentSourse: function() {
    }
  };
  constructor(props) {
    super(props);
    this.state = {
      currentSourse: 0,
      clickProps: { display: 'none' }
    };
  }
  allDisplay() {
    if (this.props.sourseList.length > 1) {
      this.state.clickProps.display === 'none' ?
        this.setState({ clickProps: { display: 'block' }}) :
        this.setState({ clickProps: { display: 'none' }});
    }
  }
  hideList() {
    if (this.state.clickProps.display === 'block') {
      this.setState({
        clickProps: { display: 'none' }
      });
    }
  }
  handleClick(index, item, event) {
    if(!item.number) {
      return false
    }else{
      this.setState({ currentSourse: index });
      if (this.props.setCurrentSourse) {
        this.props.setCurrentSourse(index, this.props.sourseList[index]);
      }
    }
  }

  render() {
    const {filterStatus, sourseList} = this.props
    return (
      <div className="menu-component">
        <div className="menu-box">
          <div className="menu-title" onClick={this.allDisplay.bind(this)}>{filterStatus == null ? sourseList[0].title : sourseList[this.state.currentSourse].title}</div>
          <div className="menu-icon" style={{ display: this.props.sourseList.length > 1 ? 'block' : 'none' }}> </div>
        </div>
        <div className="menu-list" style={{ 'display': this.state.clickProps.display }}>
          <ul className="menu-show" onClick={this.hideList.bind(this)}>
            {this.props.sourseList.map((item, index) => {
              return (
                <li onClick={this.handleClick.bind(this, index, item, event)} key={index} style={{cursor: !item.number ? 'not-allowed' : 'pointer', background:  !item.number ? '#F5F8FA' : '#fff'}}>
                  <span>{item.title}</span>
                  <span className="menu-num"> （{item.number}）</span>
                </li>
              );
            })}
          </ul>
          <div className="all-menu" onClick={this.hideList.bind(this)}></div>
        </div>
      </div>
    );
  }
}
MenuList.propTypes = {
  sourseList: PropTypes.array.isRequired, // 父组件传入的数组，渲染列表
  setCurrentSourse: PropTypes.func.isRequired // 传给父组件点击事件所得到的参数
};
