import React, { Component } from 'react';
import BaseComponent from '&/components/BaseComponent';
require('./Node.scss');

export default class extends BaseComponent {
  constructor(props) {
    super(props);
	}
  /**
  * 节点挂载完成后，计算各个相邻节点之间的距离得出连接两点之间线段的长度，并且根据当前节点的状态配置连接线的样式
  */
  componentDidMount() {
    //当前节点到左侧的距离
    const eleLeft = this.currentDom.offsetLeft;
    const eleWidth = this.currentDom.offsetWidth;

    if(this.props.status === 'current' || this.props.isLast) {
        this.props.backActiveStage && this.props.backActiveStage({type: this.props.isLast ? 'last' : 'active', left: eleLeft, width: eleWidth})
    }
  }

  render () {
    return (<div className={`${this.props.status} node-container`} ref={current => this.currentDom = current}>
              <span className='num'>{this.props.status !== 'before' ? this.props.index + 1 : ''}</span>
              <span className='txt'>{this.props.text}</span>
              {!this.props.isLast && <span className='omit'></span>} 
            </div>);
  }
}