import React, { Component } from 'react'
// import Popover from 'antd/lib/popover';
import Trigger from 'rc-trigger';
import placements from '&/helper/placements';
import AntdTable from 'antd/lib/table'
require('antd/lib/table/style/css');
// const content = (
//   <div>
//     <p>Content</p>
//     <p>Content</p>
//   </div>
// );
export default class Popover extends Component {
  constructor(props) {
    super(props)
    this.state = {
      popoverVisible: false,
      actionType: 0,
      btnName: '',
      data: [],
    }
  }

  formatJobTableData = (res) => {
    return res.map((i, index) => {
      return {
        ..._.omit(i, ['PhaseName', 'StatusName']),
        PhaseAndStatusName: i.PhaseName + '-' + i.StatusName,
        JobNameCode:{
          JobName: i.JobName,
          JobCode: i.JobCode
        },
        HrDuty: {
          HrDutyEmail: i.HrDutyEmail,
          HrDutyMobile: i.HrDutyMobile,
          HrDutyName: i.HrDutyName
        },
        key: index
      };
    });
  }

  getJobColumns = () => {
    let { actionType, cadidateIdData } = this.props
    let res = []
    switch(actionType) {
      case 7: case 30:
        res = [{
          title: '字段',
          dataIndex: 'Label',
          key: 'Label',
          // width: 120
        }, {
          title: '原值',
          dataIndex: 'BeforeValue',
          key: 'BeforeValue',
          // width: 120
        }, {
          title: '新值',
          dataIndex: 'AfterValue',
          key: 'AfterValue',
          // width: 120
        }]
        break;
      case 28:

        res = [{
          title: '字段',
          dataIndex: 'Label',
          key: 'Label',
          // width: 120
        }, {
          title: '合并前' + cadidateIdData.BeforeValueO,
          dataIndex: 'BeforeValueO',
          key: 'BeforeValueO',
          // width: 120
        }, {
          title: '合并前' + cadidateIdData.BeforeValueT,
          dataIndex: 'BeforeValueT',
          key: 'BeforeValueT',
          // width: 120
        }, {
          title: '合并为' + cadidateIdData.AfterValue,
          dataIndex: 'AfterValue',
          key: 'AfterValue',
          // width: 120
        }]
        break;
    }
    return res;
  }
  getJobTableProps = () => {
    const { data } = this.props;
    return {
      className: 'table-module',
      size: 'small',
      dataSource: data,
      columns: this.getJobColumns(),
      pagination: false,
      // scroll: { y: 160 }
    };
  }

  handlePopoverVisibleChange = () => {
    this.setState({ popoverVisible: !this.state.popoverVisible });
  }
  getPopupElement = () => {
    return (
      <div className="table-popup-wrapper popover-wrapper">
        <div className="table-popup__arrow" ref={e => {
          this.arrowRef = e;
        }}
        />
        <AntdTable {...this.getJobTableProps()} />
      </div>
    );
  }
  render() {
    return (
      <span className="popover">
        {
          this.props.actionType === 28 &&
          <span><br />{this.props.mergeContent}<br />{this.props.mergeStr}</span>
        }
        {
          this.props.actionType === 30 &&
          <span><br />{this.props.repeatStr}</span>
        }
        <Trigger
          action={['click']}
          builtinPlacements={placements}
          popupClassName={'table-popup-container'}
          popupPlacement={'bottom'}
          popup={this.getPopupElement()}
          popupVisible={this.state.popoverVisible}
          onPopupVisibleChange={this.handlePopoverVisibleChange}>
          <a href="javascript:void(0);">{this.props.btnName}</a>
        </Trigger>
      </span>
    )
  }
}