import * as React from 'react';
import Modal from 'antd/lib/modal'
import RelationRequirementContent from './relation-requirement-content'
import Loading from '@beisen/loading';
import Notice from "ux-tms-notice";

import 'antd/lib/modal/style/css';

export default class extends React.Component {

  static defaultProps = {
    visible: true,
    title: '招聘需求',
    okText: '确定',
    cancelText: '取消',
    onSure: () => {},
    onCancel: () => {}
  }

  constructor(props) {
    super(props);
    this.state = {
      isLoading: false
    }
  }

  setLoading = (data) => {
    this.setState({ isLoading: data });
  }

  handleOnSure = () => {
    this.ele.handleOnSure && this.ele.handleOnSure()
  }

  handleOnCancel = () => {
    this.props.onCancel();
  }

  render() {
    const { title, visible, okText, cancelText, onSure, relIds, pids, fromJobId, tenantId } = this.props;
    const contentProps = {
      onSure,
      relIds,
      pids,
      fromJobId,
      tenantId,
      setLoading: this.setLoading
    };
    return (
      <Modal
        visible={visible}
        title={title}
        okText={okText}
        cancelText={cancelText}
        onOk={this.handleOnSure}
        onCancel={this.handleOnCancel}
        maskClosable={false}
        width={680}
        className={'relation-requirement'}
        centered={true}
        zIndex={9999}
      >
        {this.state.isLoading ? <Loading /> : null}
        <RelationRequirementContent {...contentProps} ref={ele => { this.ele = ele }} />
      </Modal>
    )
  }
}
