import * as React from 'react';
import RequirementContent from './requirement-content';
import Notice from 'ux-tms-notice';
import Modal from 'antd/lib/modal'

import 'antd/lib/tabs/style/css';
import 'antd/lib/checkbox/style/css';
import 'antd/lib/modal/style/css';
export default class RelationRequirementPopup extends React.Component {

  static defaultProps = {
    setLoading: () => {},
    onSure: () => {},
    relIds: [],
    pids: [],
    fromJobId: []
  }

  constructor(props) {
    super(props);
    this.state = {
      selected: []
    }
  }

  handleOnSure = () => {
    if (this.state.selected.length) {
      this.saveSelectedRequirement()
    }
  }

  saveSelectedRequirement = () => {
    this.props.setLoading(true);
    const {pids, tenantId, relIds} = this.props
    let requirementId = this.state.selected[0]['RecruitRequirementGuid'];
    let url = '/Recruiting/ApplicantProcess/EditApplyInfoRequirement';
    let bodyData = {
      tenantId: tenantId,
      requirementId: requirementId,
      personIds: pids,
      applyId: relIds
    };
    const options = {
      headers: {
        'Accept': 'application/json, application/xml, text/play, text/html, *.*',
        'Content-Type':' application/json; charset=utf-8',
        'x-beisen-ajax': 1.0,
        'X-Beisen-ts': new Date().getTime(),
        'x-referer': window.location.hash
      },
      credentials: 'same-origin',
      method: 'POST',
      body: JSON.stringify(bodyData)
    };
    fetch(url, options).then(res => {
      if (res.ok) {
        return res.json();
      }
    }).then(data => {
      this.props.setLoading(false);
      this.props.onSure(data)
    });
  }


  handleTableSelected = (data) => {
    this.setState({ selected: data });
  }

  render() {
    const {selected } = this.state;
    const {tenantId, fromJobId} = this.props
    return (
      <div className='popup-wrapper'>
        <RequirementContent selected={selected} handleTableSelected={this.handleTableSelected} tenantId={tenantId} fromJobId={fromJobId} multiple={false}/>
      </div>
    );
  }
}
