import addDOMEventListener from 'add-dom-event-listener';
import ReactDOM from 'react-dom';

export function addEventListenerWrap (target, eventType, cb) {
  /* eslint camelcase: 2 */
  var callback = ReactDOM.unstable_batchedUpdates ? function run (e) {
    ReactDOM.unstable_batchedUpdates(cb, e)
  } : cb
  return addDOMEventListener(target, eventType, callback)
};

// 序列化url
export function serialize (obj) {
  var result = []
  for (var k in obj) {
    if (Array.isArray(obj[k])) {
      obj[k] = JSON.stringify(obj[k])
    }
    result.push(encodeURIComponent(k) + '=' + encodeURIComponent(obj[k]))
  }
  return result.join('&')
}

export function getQueryObj () {
  // let hash = window.location.hash
  let hash = decodeURIComponent(window.location.hash)
  let searchsIndex = hash.indexOf('?')
  if (searchsIndex === -1) return {}
  let searchs = hash.substring(searchsIndex + 1)
  let keysArr = searchs.split('&')
  if (keysArr.length === 1) {
    let arr = keysArr[0].split('=')
    return {
      [arr[0]]: arr[1]
    }
  }
  return keysArr.reduce((pre = {}, cur) => {
    let curArr = cur.split('=')
    if (typeof pre === 'string') {
      let preArr = pre.split('=')
      return {
        [preArr[0]]: preArr[1],
        [curArr[0]]: curArr[1]
      }
    }
    return {
      ...pre,
      [curArr[0]]: curArr[1]
    }
  })
}
