import React, { Component } from 'react'
import BaseComponent from '../BaseComponent'
import Modal from 'antd/lib/modal'
import Button from 'antd/lib/button'
import Hurdle from '&/components/hurdle'
require('antd/lib/modal/style/css/')

import './index.scss'

export default class RemarkPopup extends BaseComponent {
  constructor(props) {
		super(props)
		this.state = {
			visible: this.props.visible
		}
	}
	
	componentWillReceiveProps(nextProps) {
		if (nextProps.visible !== this.state.visible) {
			this.setState({visible: nextProps.visible})
		}
	}

	onCancelHandler = (e) => {
		this.setState({visible: false}, this.props.onCancelHandler && this.props.onCancelHandler())
	}

	getFooter = () => {
    return (
      <div>
        <Button onClick={this.onCancelHandler}>关闭</Button>
      </div>
    )
	}
	
  render () {
		return this.state.visible ? <Modal title='备注'
			className='remark-popup'
			centered={true}
			visible={this.state.visible}
			onCancel={this.onCancelHandler}
			footer={this.getFooter()}
			maskClosable={false}
			width={600}
			>
			<div className='pop-message-container'></div>
			<Hurdle {...this.props}
						mode={'big'}
						type='block'
						parentClass='remark-popup'
            />
		</Modal> : null
  }
}
