import React,{ Component } from 'react';
import BaseComponent from '../BaseComponent';
require('./SelectButtontop.scss');

export default class extends BaseComponent{
    constructor(props){
        super(props);
        // this.handlebutton = this.handlebutton.bind(this);
        this.onArrowClick = this.onArrowClick.bind(this);
        this.state = {
            dataSource: this.props.dataSource
        };
    }

    componentDidMount() {
        window.requestAnimationFrame(() => {
            this.scrollDom.style.left = '0px'
            const contentDomSize = this.contentDom.getBoundingClientRect()
            const scrollDomSize = this.scrollDom.getBoundingClientRect()
            if (scrollDomSize.width > contentDomSize.width) {
                this.scrollDom.className = 'scroll-content leftalign';
                window.requestAnimationFrame(() => {
                    const activeLeft = this.activeBtn && this.activeBtn.offsetLeft || 0;
                    //一页的长度
                    this.pageLen = this.contentDom.offsetWidth;

                    //可以滚动的距离
                    this.distances = this.scrollDom.offsetWidth - this.pageLen;

                    //可以滚动的总页数
                    this.pages = Math.abs(this.distances / this.pageLen);

                    //当前页数
                    const page = (activeLeft - this.pageLen) / this.pageLen;


                    if(this.distances <= 0){
                    document.getElementsByClassName('arrow left')[0].style.display = 'none';
                    document.getElementsByClassName('arrow right')[0].style.display = 'none';
                    }else {
                    this.scrollDom.className = 'scroll-content leftalign';
                    }
                    if(activeLeft > this.pageLen) {
                        this.scrollDom.style.left = `-${(page + 1) >= this.pages ? Math.abs(this.distances) : (page + 1) * this.pageLen}px`;
                    }else {
                        this.scrollDom.style.left = '0px'
                    }
                })
            }
        })


        // this.scrollDom.style.left = '0px'
        // setTimeout(() => {
        //     const activeLeft = this.activeBtn && this.activeBtn.offsetLeft || 0;
        //     //一页的长度
        //     this.pageLen = this.contentDom.offsetWidth;

        //     //可以滚动的距离
        //     this.distances = this.scrollDom.offsetWidth - this.pageLen;

        //     //可以滚动的总页数
        //     this.pages = Math.abs(this.distances / this.pageLen);

        //     //当前页数
        //     const page = (activeLeft - this.pageLen) / this.pageLen;


        //     if(this.distances <= 0){
        //     document.getElementsByClassName('arrow left')[0].style.display = 'none';
        //     document.getElementsByClassName('arrow right')[0].style.display = 'none';
        //     }else {
        //     this.scrollDom.className = 'scroll-content leftalign';
        //     }
        //     if(activeLeft > this.pageLen) {
        //         this.scrollDom.style.left = `-${(page + 1) >= this.pages ? Math.abs(this.distances) : (page + 1) * this.pageLen}px`;
        //     }else {
        //         this.scrollDom.style.left = '0px'
        //     }
        // }, 500)
    }

    componentWillReceiveProps(nextProps) {
        this.setState({'dataSource': nextProps.dataSource})
    }

    clickFork  = (index) => (e) => {
      // 在react中阻止默认事件与冒泡不能直接使用stopPropagation，preventDefault
      e.stopPropagation() || e.nativeEvent.stopPropagation()
      e.preventDefault();
      // dataFork为事件抛出函数
      this.props.clickClose && this.props.clickClose(index)
    }

    handlebutton(point) {
        this.state.dataSource.forEach((data,index) => {
            data[this.props.activeFieldName] = (point === index ? true : false);
        });
        this.setState({dataSource: this.state.dataSource});
        this.props.stateChange ? this.props.stateChange(this.props.dataSource[key]) : null;
    }
    /**
    * 滚动按钮点击事件：点击一次滚动一页，不够一页滚动剩余部分
    */
    onArrowClick(e) {
        if(this.distances <= 0) {
            return ;
        }
        if(this.distances <= 0) {
            this.refs.arrowL.style.visibility = 'hidden';
            this.refs.arrowR.style.visibility = 'hidden';
        }
        //是否点击右侧按钮
        const isRight = e.target && e.target.className.match('right');
        //需要滚动元素left值
        const domLeft = Math.abs(parseInt(this.scrollDom.style.left || 0));
        //当前页数
        const page = domLeft / this.contentDom.offsetWidth;

        this.scrollDom.style.left = '-' + (isRight ? ((page + 1) >= this.pages ? Math.abs(this.distances) : (page + 1) * this.pageLen) : page - 1 <= 0 ? 0 : (page - 1) * this.pageLen) + 'px';
    }

    render(){
        return (
            <div className = "selectbuttontop-container">
                <div className='arrow left' ref='arrowL' onClick={this.onArrowClick}/>
                <div className='content' ref={content => {this.contentDom = content}}>
                    <div className='scroll-content' ref={scroll => {this.scrollDom = scroll}}>
                        {
                            this.state.dataSource.map((ele,index) => {
                              return <div tabIndex={index}
                                        key={index}
                                        className={`${ele[this.props.activeFieldName] && 'active'} default button`}
                                        onClick={() => {this.props.onChange && this.props.onChange(index)}}
                                        ref={activeBtn => {if(ele[this.props.activeFieldName]){this.activeBtn = activeBtn};if(this.state.dataSource.length-1 === index){this.lastBtn = activeBtn}}}
                                        >
                                        <span className='txt'>{ele[this.props.fieldName]}</span>
                                        <span className='selectbuttton_false' onClick={this.clickFork(index)}></span>
                                     </div>
                            })
                        }
                    </div>
                </div>
                <div className='arrow right' ref='arrowR' onClick={this.onArrowClick}/>
            </div>
        )
    }
}
