import React,{ Component } from 'react';
import BaseComponent from '../BaseComponent';
import moment from 'moment';
import Card from '../card';
require ('./SmallSpan.scss');

export default class extends Component{
    static defaultProps = {
      isShowSmallTips: true
    }

    constructor(props){
        super(props);
        this.dataSource = Object.prototype.toString.call(this.props.dataSource) === '[object Array]' ? this.props.dataSource : [];
        this.handleEnter = this.handleEnter.bind(this);
        this.handleOut = this.handleOut.bind(this)
    }

    handleEnter(e){
        this.refs[e] && this.refs[e].handleEnter();
    }

    handleOut(e){
        this.refs[e] && this.refs[e].handleOut();
    }

    render(){
        if(this.props.dataSource[0] && this.props.dataSource[0]['text'] === '猎' && this.props.dataSource[0].tips[0] && this.props.dataSource[0].tips[0]['value']){
            this.props.dataSource[0].tips[0]['value'] = moment(this.props.dataSource[0].tips[0]['value']).format('LL');
        }
        return(
            <div className = "Smallspan_bod">
                {this.dataSource.map((ele,index) => {
                    return (
                      ele.show ? <span onMouseOut={this.handleOut.bind(this,ele.text)}
                              onMouseEnter={this.handleEnter.bind(this,ele.text)}
                              key={index}
                              className="Smallspan_main"
                              >{ele.text}
                              {this.props.isShowSmallTips ? <Card dataSource={ele} ref={ele.text}/> : null}
                        </span> : null
                    )
                  }
         )}
            </div>
        )
    }
}
