import React, { Component } from 'react';
import PropTypes from 'prop-types';
import BaseComponent from '../BaseComponent';
import StatisticsItem from './StatisticsItem';
require('./index.scss');

export default class Statistics extends BaseComponent {
    static defaultProps = {
        //是否显示人脉
        isShowConnection: true
    }

  	constructor(props) {
  		super(props);
      this.onSwitch = this.onSwitch.bind(this);
  	}

    onSwitch(ele) {
        this.props.switchJob && this.props.switchJob(ele)
    }

    render () {
      return (<div className='statistics-container'>
                {
                    this.props.init ? <div className='statistics-loading'></div>:
                    this.props.dataSource.map((data, index) => {
                        return !this.props.isShowConnection && index > 0 ? null : <StatisticsItem key={index} {...data} activeIndex={this.props.activeIndex} onSwitch={this.onSwitch}/>;
                    })
                }
    		  </div>);
    }
}
Statistics.propTypes = {
    dataSource: PropTypes.array
};
