import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import Card from '../card';
import MentionEditor from 'recruit-richarea'
require('./index.scss');

export default class extends BaseComponent {
	constructor(props) {
    super(props);
    this.inDom = React.createRef()
    this.saveBtnDom = React.createRef()
    this.mentionEditor = React.createRef()
    this.count = 0
  }

  onInFocusHandler = () => {
    this.props.onFocusChange && this.props.onFocusChange()
  }

  onInBlurHandler = () => {
    // this.props.onBlurChange && this.props.onBlurChange()
  }

  onClickSaveHandler = (value) => {
    this.props.addHandler && this.props.addHandler(value)
  }

  openBigRemarkPop = (e) => {
    e.preventDefault()
    e.stopPropagation()
    this.props.openRemarkPop && this.props.openRemarkPop()
  }
  
  replyHandler = (ele) => {
    this.mentionEditor && this.mentionEditor.current.onInsert(ele)
  }

  render () {
      return (<div className='subentry-container'>
              {this.props.isDisplayHeader && <div className='head'>
                  <div className='left'>
                      <span className='line'></span>
                      <span className='title'>{this.props.title || ''}</span>
                      <span className='num'>
                          {`(${this.props.num || 0})`}
                      </span>
                  </div>
                  { this.props.isShowOpenRemarkPopBtn && !!this.props.num &&
                    <div className='right' onClick={this.openBigRemarkPop}>
                      <span className='show-all'>展开</span>
                      <span className='icon'></span>
                    </div>
                  }
              </div>}
              <div className='center'>
                  <div className='textarea-container'>
                      <div className='textarea-content'>
                          <MentionEditor ref={this.mentionEditor}
                            saveTitle={this.props.saveTitle}
                            placeholder={this.props.placeholder}
                            getUserList={this.props.getUserList}
                            onFocus={this.onInFocusHandler}
                            onBlur={this.onInBlurHandler}
                            onSubmit={this.onClickSaveHandler}
                            userTotal={this.props.userTotal}
                            isDisplayPrivateBtn={this.props.isDisplayPrivateBtn}
                            parentClass={this.props.parentClass}
                          />
                      </div>
                  </div>
                  {this.props.children}
              </div>
        </div>);
  }
}
