import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import TabItem from './TabItem';
import * as drag from '../util/drag';
require('./index.scss');

export default class extends BaseComponent {
	constructor(props) {
		super(props);
		this.itemClickHandler = this.itemClickHandler.bind(this);

		this.tabList = props.dataSource || [];
	}

	itemClickHandler(sub) {
		console.log(sub);
	}

    render () {
      return (<div className='tab-container'>
      			<div className='tab' ref={tab => {drag.startDrag(tab, tab);}}>
      			{
      				this.tabList.map((item, index) => {
      					return <TabItem key={index}
      									{...item}
      									itemClickHandler={this.itemClickHandler}
      									/>;
      				})
      			}
    			</div>
    		  </div>);
    }
}