import React, { Component } from 'react';
import BaseComponent from '../BaseComponent';
import './index.scss'

export default class extends BaseComponent {
	constructor(props) {
		super(props);
		this.itemClickHandler = this.itemClickHandler.bind(this);

    this.state = {
      active: 0
    }
    this.tabList = props.dataSource || [];
	}

	itemClickHandler(e) {
    e.preventDefault()
    e.stopPropagation()
    this.setState({
      active: parseInt(e.target.getAttribute('index'))
    })
	}

  render () {
    return (<div className='tabBar-container'>
              <ul>
                {
                  this.tabList.map((item, index) => {
                    return <li key={index} index={index} className={this.state.active === index && 'active'} onClick={this.itemClickHandler}>{item['sub']}</li>
                  }) 
                }
              </ul>
        </div>);
  }
}