let params = {
    left: 0,
    top: 0,
    currentX: 0,
    currentY: 0,
    flag: false
};

const getCss = function (o, key) {
    return o && (o.currentStyle ? o.currentStyle[key] : document.defaultView.getComputedStyle(o, false)[key]);
};
/**
* 拖拽
* params bar：触发拖拽对象，target：拖拽对象，isTop：纵向是否也支持拖拽
*/
export const startDrag = function (bar, target, isTop=false, callback) {
    if(!bar && !target) {
        return false;
    }
    if (getCss(target, "left") !== "auto") {
        params.left = getCss(target, "left");
    }
    if (getCss(target, "top") !== "auto") {
        params.top = getCss(target, "top");
    }
    const parentWidth = getCss(target.offsetParent, 'width');
    const targetWidth = getCss(target, 'width');
    //o鏄Щ鍔ㄥ璞�
    bar.onmousedown = function (event) {
        params.flag = true;
        if (!event) {
            event = window.event;
            //闃叉IE鏂囧瓧閫変腑
            bar.onselectstart = function () {
                return false;
            };
        }
        const e = event;
        params.currentX = e.clientX;
        params.currentY = e.clientY;
    };
    document.onmouseup = function () {
        params.flag = false;
        if (getCss(target, "left") !== "auto") {
            params.left = getCss(target, "left");
        }
        if (getCss(target, "top") !== "auto") {
            params.top = getCss(target, "top");
        }
    };
    document.onmousemove = function (event) {
        const e = event ? event : window.event;
        if (params.flag) {
            const nowX = e.clientX,
                  nowY = e.clientY;
            const disX = nowX - params.currentX,
                  disY = nowY - params.currentY;
            const x = parseInt(params.left) + disX;
            //当偏移距离即将超过可便宜距离时停下
            if(Math.abs(parseInt(targetWidth) - parseInt(parentWidth)) < Math.abs(x)) {
                return false;
            }
            target.style.left = (x > 0 ? 0 : x)  + "px";
            target.style.top = isTop ? (parseInt(params.top) + disY) : 0 + "px";
 
            if (typeof callback == "function") {
                callback((parseInt(params.left) || 0) + disX, (parseInt(params.top) || 0) + disY);
            }
 
            if (event.preventDefault) {
                event.preventDefault();
            }
            return false;
        }
    };
};