export function getUserInfo () {
  const userInfo = BSGlobal.generalData.CurrentUser
  return {
    id: userInfo.UserID,
    name: userInfo.Name,
    email: userInfo.Email
  }
}

export function getTenantInfo () {
  const tenantInfo = BSGlobal.generalData.CurrentTenant
  return {
    id: tenantInfo.ID,
    name: tenantInfo.Alias,
    logo: tenantInfo.LogoUrl,
    status: BSGlobal.generalData.CurrentProduct && BSGlobal.generalData.CurrentProduct.Status
  }
}

export function getQueryObj () {
  // let hash = window.location.hash
  let hash = decodeURIComponent(window.location.hash)
  let searchsIndex = hash.indexOf('?')
  if (searchsIndex === -1) return {}
  let searchs = hash.substring(searchsIndex + 1)
  let keysArr = searchs.split('&')
  if (keysArr.length === 1) {
    let arr = keysArr[0].split('=')
    return {
      [arr[0]]: arr[1]
    }
  }
  return keysArr.reduce((pre = {}, cur) => {
    let curArr = cur.split('=')
    if (typeof pre === 'string') {
      let preArr = pre.split('=')
      return {
        [preArr[0]]: preArr[1],
        [curArr[0]]: curArr[1]
      }
    }
    return {
      ...pre,
      [curArr[0]]: curArr[1]
    }
  })
}

