
export default (Vuex) => {
  let _dispatch = Vuex.Store.prototype.dispatch

  Vuex.Store.prototype.dispatch = function _self (type, payload = {}) {
    let { promise, pass } = payload

    /* 跳过该 action，继续下一个 action */
    if (pass) {
      if (promise && promise.resolve) {
        promise.resolve = Array.isArray(promise.resolve) ? promise.resolve : [promise.resolve]
        promise.resolve.forEach((item) => {
          item.params = Object.assign({}, item.params, payload.params)
          item.context = Object.assign({}, item.context, payload.context)
          item.event = Object.assign({}, item.event, payload.event)
          return _self.call(this, item.type, item, { root: true })
        })
      }
      return
    }

    /* 不包含事件流 action */
    if (!promise) return _dispatch.apply(this, arguments)

    return _dispatch.apply(this, arguments)
      .then(response => {
        if (promise.resolve) {
          promise.resolve = Array.isArray(promise.resolve) ? promise.resolve : [promise.resolve]
          promise.resolve && promise.resolve.forEach((item) => {
            item.params = Object.assign({}, item.params, response)
            item.context = Object.assign({}, item.context, payload.context)
            item.event = Object.assign({}, item.event, payload.event)
            return _self.call(this, item.type, item, {
              root: true
            })
          })
        }
      })
      .catch(response => {
        if (promise.reject) {
          promise.reject = Array.isArray(promise.reject) ? promise.reject : [promise.reject]
          promise.reject && promise.reject.forEach((item) => {
            item.params = Object.assign({}, item.params, response)
            item.context = Object.assign({}, item.context, payload.context)
            item.event = Object.assign({}, item.event, payload.event)
            return _self.call(this, item.type, item, {
              root: true
            })
          })
        }
      })
  }
}
