
export default (dispatcher = () => {}) => (component = {}) => {
  let { name = '', attributes = {} } = component
  let { events = {} } = attributes
  let cmpOnEvents = {}

  Object.keys(events).forEach(eventName => {
    cmpOnEvents[eventName] = (...eventArgs) => {
      let eventActions = events[eventName]
      eventActions = Array.isArray(eventActions) ? eventActions : [ eventActions ]

      eventActions.forEach(actionMetaData => {
        let { type, params = {}, promise = null, context = {}, disabled } = actionMetaData

        if (disabled !== true) {
          dispatcher(
            type, {
              params, /* 参数 */
              promise, /* 事件流参数 */
              context, /* 上下文环境变量 */
              'event': {
                /* 组件抛出事件中的参数 */
                arguments: eventArgs,
                target: {
                  /* 触发时间的组件源数据ID */
                  name
                }
              }
            }
          )
        }
      })
    }
  })

  return cmpOnEvents
}
