
export default (bindEvents = () => {}) => function _self (createElement, component, components = {}) {
  if (!component) return null
  if (!Object.keys(component).length) return null

  let { type = '', children = [], attributes = {} } = component
  let { slot ='', props = {} } = attributes

  /* 拼装默认渲染器(Vue), 使用的源数据格式 */
  // let attributes = Object.assign(
  //   {},
  //   component.attributes,
  //   {
  //     /* 绑定元数据中配置的事件 */
  //     on: bindEvents(component)
  //   }
  // )

  /*
  * container:
  * 外部可配置自定义解析器, 解析器中接受当前组件的源数据
  * 没有配置该属性的组件元数据，将使用默认方式(Vue)生成组件
  */
  // if (container && container.type) {
  //   /* 配置了container的源数据, 渲染的组件是对应的container.type组件 */
  //   type = container.type
  //   attributes = Object.assign(
  //     {},
  //     {
  //       props: {
  //          外界对container组件配置的属性 
  //         ...(container.attributes && container.attributes.props || {}) || {},
  //         /* 全量组件元数据传入container组件, 由container组件内部提供组件渲染 */
  //         component
  //       },
  //       slot
  //     }
  //   )
  // }
  // 默认为react组件
  // let shareComKeys = Object.keys(window.shareComponents)
  //   for (let i in shareComKeys) {
  //     if (type === shareComKeys[i]) {
  //       return createElement(window.shareComponents[type], attributes.props, children.map(function (child) {
  //       return _self(createElement, child);
  //     }));
  //     }
  //   }
  if (!components[type]) return  // 在pagebuilder上已注册的组件在共享库找不到
  /* 通过元数据生成真实组件 */
  return createElement(components[type], { ...props, slot }, children.map(child => {
    return _self(createElement, child, components)
  }))
}
