
import cmpFormat from './cmp-format'
import cmpsTreeMaker from './cmps-tree-maker'

export default (tubState) => {
  let cmpsTree = cmpsTreeMaker(tubState)

  /* pageBuilder 组件转化为 upaas组件 1对多 的关系 */
  let upaasCmps = (function _self(cmpsTree) {
    let resUpaasCmps = []
    let children = []

    for (let i = 0; i < cmpsTree.length; i++) {
      let pgCmp = cmpsTree[i]

      /* 递归开始 */
      if (pgCmp.children && pgCmp.children.length) {
        pgCmp.children = _self(pgCmp.children)
      }

      /* 生成 upaas 组件元数据 */
      let upaasCmpData = cmpFormat(pgCmp)

      resUpaasCmps.push(upaasCmpData)
    }

    return resUpaasCmps
  })(cmpsTree)

  let pageSettingUpaasCmpData = cmpFormat(tubState.pageSettings)

  return {
    ...pageSettingUpaasCmpData,
    'children': upaasCmps
  }
}
